/*******************************************************************************
 * FoxGameMP_SND generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxGameMP_SND extends FoxGameMP_TDM
    native
    config(Game)
    hidecategories(Navigation,Movement,Collision);

var const int AttackingTeamIndex;
var const int DefendingTeamIndex;
var FoxGRI_SND SNDGRI;
var array<FoxGameObject_BombTarget> BombTargets;
var bool bNeedBombCarrier;
var FoxPC PendingBombPickupPlayer;

function InitGameReplicationInfo()
{
    super.InitGameReplicationInfo();
    SNDGRI = FoxGRI_SND(GameReplicationInfo);
    //return;    
}

function RegisterBombTarget(FoxGameObject_BombTarget NewTarget)
{
    // End:0x36
    if(BombTargets.Find(NewTarget) == -1)
    {
        BombTargets.AddItem(NewTarget);
    }
    //return;    
}

function BombDestroyed()
{
    // End:0xA1
    if((FGRI.bMatchHasBegun && !FGRI.bMatchIsOver) && !FGRI.bRoundInTransition)
    {
        SNDGRI.BombObject = none;
        SetTimer(1.0, false, 'OnDelayedRespawnBomb');
    }
    //return;    
}

function BombPickedUp(FoxGameObject_Bomb Bomb, FoxPRI FoxPRI)
{
    // End:0x66
    if(!FGRI.bSpawnFreeze)
    {
        BroadcastPawnUseDialog(0,, byte(FoxPRI.Team.TeamIndex));
    }
    // End:0x134
    if(!bNeedBombCarrier && (Bomb.LastCarriedPawn == none) || Bomb.LastCarriedPawn.PlayerReplicationInfo != FoxPRI)
    {
        ScoreEvent(FoxPRI, 1);
        BroadcastEvent(FoxPRI.Team.TeamIndex, 62);
    }
    FoxOnlineStatsWriteGameTypeSND(FoxPRI.GameTypeStats).IncrementBombPossesions();
    //return;    
}

function PlantBomb(FoxPC Planter, FoxGameObject_BombTarget BombTarget)
{
    local FoxPRI PlanterPRI;

    PlanterPRI = FoxPRI(Planter.PlayerReplicationInfo);
    // End:0x140
    if(SNDGRI.BombObject != none)
    {
        FoxOnlineStatsWriteGameTypeSND(PlanterPRI.GameTypeStats).IncrementBombPlants();
        SNDGRI.BombObject.Planter = PlanterPRI;
        SNDGRI.BombObject.PlantBomb();
        SNDGRI.BombObject.PlantedTarget = BombTarget;
    }
    // End:0x170
    if(BombTarget != none)
    {
        BombTarget.bBombPlanted = true;
    }
    ScoreEvent(FoxPRI(Planter.PlayerReplicationInfo), 56);
    BroadcastEvent(Planter.PlayerReplicationInfo.Team.TeamIndex, 59, true);
    //return;    
}

function DefuseBomb(FoxPC Defuser)
{
    ScoreEvent(FoxPRI(Defuser.PlayerReplicationInfo), 57);
    BroadcastEvent(Defuser.PlayerReplicationInfo.Team.TeamIndex, 60, true);
    FoxOnlineStatsWriteGameTypeSND(FoxPRI(Defuser.PlayerReplicationInfo).GameTypeStats).IncrementBombDefusals();
    // End:0x13C
    if(SNDGRI.BombObject != none)
    {
        SNDGRI.BombObject.OnBombDefused();
    }
    Teams[DefendingTeamIndex].Score += float(1);
    CachedForcedWinningTeamIndex = DefendingTeamIndex;
    DelayedRoundEnd(3.0);
    //return;    
}

function NotifyBombExplode()
{
    local int I;
    local FoxPC PC;

    I = 0;
    J0x0B:
    // End:0x86 [Loop If]
    if(I < BombTargets.Length)
    {
        // End:0x78
        if(BombTargets[I].bBombPlanted)
        {
            BombTargets[I].NotifyExploded();
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    BroadcastEvent(AttackingTeamIndex, 61, true);
    Teams[AttackingTeamIndex].Score += float(1);
    CachedForcedWinningTeamIndex = AttackingTeamIndex;
    // End:0x131
    foreach WorldInfo.AllControllers(class'FoxPC', PC)
    {
        PC.DisablePauseMenu();        
    }    
    DelayedRoundEnd(4.0);
    EMPAllPlayers(1.0);
    //return;    
}

function EMPAllPlayers(optional float DelayTime)
{
    local FoxPC PC;

    // End:0x2C
    if(DelayTime > float(0))
    {
        SetTimer(DelayTime, false, 'EMPAllPlayers');
    }
    // End:0x86
    else
    {
        // End:0x85
        foreach WorldInfo.AllControllers(class'FoxPC', PC)
        {
            PC.ClientDoFlashEffect(3.0);            
        }        
    }
    //return;    
}

function TimeLimitReached()
{
    // End:0x96
    if((SNDGRI.BombObject == none) || !SNDGRI.BombObject.bIsPlanted)
    {
        Teams[DefendingTeamIndex].Score += float(1);
        EndRound();
    }
    //return;    
}

function bool CheckEndSpawnTicketRound()
{
    local int NumTicketPlayersAliveAttackTeam, NumTicketPlayersAliveDefendTeam, NumPlayersSpawnedAttackTeam, NumPlayersSpawnedDefendTeam, NumTicketBotsAliveAttackTeam, NumTicketBotsAliveDefendTeam,
	    NumBotsSpawnedAttackTeam, NumBotsSpawnedDefendTeam, NumTicketTotalAliveAttackTeam, NumTicketTotalAliveDefendTeam, NumTotalSpawnedAttackTeam,
	    NumTotalSpawnedDefendTeam;

    // End:0x3A
    if((FGRI.SpawnTicketType == 0) || IsRoundOrGameEnding())
    {
        return false;
    }
    NumTicketPlayersAliveAttackTeam = GetNumRemainingTicketPlayers(AttackingTeamIndex);
    NumTicketPlayersAliveDefendTeam = GetNumRemainingTicketPlayers(DefendingTeamIndex);
    NumPlayersSpawnedAttackTeam = GetNumSpawnedInPlayers(AttackingTeamIndex);
    NumPlayersSpawnedDefendTeam = GetNumSpawnedInPlayers(DefendingTeamIndex);
    NumTicketBotsAliveAttackTeam = GetNumRemainingTicketBots(AttackingTeamIndex);
    NumTicketBotsAliveDefendTeam = GetNumRemainingTicketBots(DefendingTeamIndex);
    NumBotsSpawnedAttackTeam = GetNumSpawnedInBots(AttackingTeamIndex);
    NumBotsSpawnedDefendTeam = GetNumSpawnedInBots(DefendingTeamIndex);
    NumTicketTotalAliveAttackTeam = NumTicketPlayersAliveAttackTeam + NumTicketBotsAliveAttackTeam;
    NumTicketTotalAliveDefendTeam = NumTicketPlayersAliveDefendTeam + NumTicketBotsAliveDefendTeam;
    NumTotalSpawnedAttackTeam = NumPlayersSpawnedAttackTeam + NumBotsSpawnedAttackTeam;
    NumTotalSpawnedDefendTeam = NumPlayersSpawnedDefendTeam + NumBotsSpawnedDefendTeam;
    // End:0x234
    if(((NumTicketTotalAliveAttackTeam > 0) && NumTicketTotalAliveDefendTeam == 0) && (NumTotalSpawnedDefendTeam > 0) || FGRI.bJoinInProgressDisabled)
    {
        CachedForcedWinningTeamIndex = AttackingTeamIndex;
        Teams[CachedForcedWinningTeamIndex].Score += float(1);
        return true;
    }
    // End:0x395
    else
    {
        // End:0x32D
        if(((NumTicketTotalAliveDefendTeam > 0) && NumTicketTotalAliveAttackTeam == 0) && (NumTotalSpawnedAttackTeam > 0) || FGRI.bJoinInProgressDisabled)
        {
            // End:0x32A
            if((SNDGRI.BombObject == none) || !SNDGRI.BombObject.bIsPlanted)
            {
                CachedForcedWinningTeamIndex = DefendingTeamIndex;
                Teams[CachedForcedWinningTeamIndex].Score += float(1);
                return true;
            }
        }
        // End:0x395
        else
        {
            // End:0x395
            if(((NumTicketTotalAliveAttackTeam == 0) && NumTicketTotalAliveDefendTeam == 0) && ((NumTotalSpawnedAttackTeam > 0) && NumTotalSpawnedDefendTeam > 0) || FGRI.bJoinInProgressDisabled)
            {
                return true;
            }
        }
    }
    return false;
    //return ReturnValue;    
}

protected function ResetForRoundEnd()
{
    super.ResetForRoundEnd();
    // End:0x7B
    if(SNDGRI.BombObject != none)
    {
        SNDGRI.BombObject.Destroy();
        SNDGRI.BombObject = none;
    }
    //return;    
}

function EndGame(PlayerReplicationInfo Winner, string Reason)
{
    super(FoxGame).EndGame(Winner, Reason);
    // End:0x8D
    if(SNDGRI.BombObject != none)
    {
        SNDGRI.BombObject.Destroy();
        SNDGRI.BombObject = none;
    }
    //return;    
}

event Killed(Controller Killer, Controller KilledPlayer, Pawn KilledPawn, class<DamageType> DamageType)
{
    local int I;
    local bool bCarrierDown;

    I = 0;
    J0x0B:
    // End:0x20C [Loop If]
    if(I < BombTargets.Length)
    {
        // End:0x1FE
        if(((BombTargets[I].bBombPlanted && BombTargets[I].IsPawnInVolume(FoxPawn(KilledPawn))) && FoxPC(KilledPlayer) != none) && FoxPC(Killer) != none)
        {
            // End:0x18D
            if(Killer.PlayerReplicationInfo.Team.TeamIndex == AttackingTeamIndex)
            {
                ++ FoxPRI(Killer.PlayerReplicationInfo).NumGameDefends;
                ScoreEvent(FoxPRI(Killer.PlayerReplicationInfo), 7);
            }
            // End:0x1FE
            else
            {
                ++ FoxPRI(Killer.PlayerReplicationInfo).NumGameAttacks;
                ScoreEvent(FoxPRI(Killer.PlayerReplicationInfo), 6);
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    // End:0x2ED
    if(((KilledPawn != none) && FoxPawn(KilledPawn).CarriedObject != none) && FoxPawn(KilledPawn).CarriedObject == SNDGRI.BombObject)
    {
        // End:0x2E1
        if(FoxPC(Killer) != none)
        {
            ScoreEvent(FoxPRI(Killer.PlayerReplicationInfo), 3);
        }
        bCarrierDown = true;
    }
    super(FoxGame).Killed(Killer, KilledPlayer, KilledPawn, DamageType);
    // End:0x38F
    if(bCarrierDown && !bPendingRoundEnd)
    {
        BroadcastEvent(KilledPlayer.PlayerReplicationInfo.Team.TeamIndex, 64);
    }
    //return;    
}

function RestartInitialBombSpawnTimer()
{
    bNeedBombCarrier = false;
    // End:0x7D
    if(SNDGRI.BombObject != none)
    {
        SNDGRI.BombObject.Destroy();
        SNDGRI.BombObject = none;
    }
    SetTimer(float(class'FoxGRI_SND'.default.DelayBeforeSpawningBomb), false, 'OnSpawnInitialBomb');
    SNDGRI.BombTimeRemaining = 0;
    SNDGRI.BombFreezeTime = 0.0;
    //return;    
}

function OnSpawnInitialBomb()
{
    local FoxPC PC;
    local array<FoxPC> EligibleBombCarriers;
    local int RandomIndex;

    bNeedBombCarrier = true;
    // End:0x147
    foreach WorldInfo.AllControllers(class'FoxPC', PC)
    {
        // End:0x146
        if((((PC.PlayerReplicationInfo.Team.TeamIndex == AttackingTeamIndex) && PC.MyFoxPawn != none) && PC.MyFoxPawn.IsAliveAndWell()) && !PC.MyFoxPawn.IsInjured())
        {
            EligibleBombCarriers.AddItem(PC);
        }        
    }    
    // End:0x18B
    if(EligibleBombCarriers.Length > 0)
    {
        RandomIndex = Rand(EligibleBombCarriers.Length);
        GiveBombToPlayer(EligibleBombCarriers[RandomIndex]);
    }
    //return;    
}

function RestartPlayer(Controller NewPlayer)
{
    super(FoxGame).RestartPlayer(NewPlayer);
    // End:0x113
    if((((bNeedBombCarrier && SNDGRI.BombObject == none) && FoxPC(NewPlayer) != none) && FoxPC(NewPlayer).MyFoxPawn != none) && NewPlayer.PlayerReplicationInfo.Team.TeamIndex == AttackingTeamIndex)
    {
        // End:0x113
        if(!IsTimerActive('OnSpawnInitialBomb'))
        {
            SetTimer(1.0, false, 'OnSpawnInitialBomb');
        }
    }
    //return;    
}

function GiveBombToPlayer(FoxPC InPlayer)
{
    local class<FoxGameObject_Bomb> BombClass;
    local FoxPC PC;

    // End:0x281
    if(bNeedBombCarrier)
    {
        PendingBombPickupPlayer = InPlayer;
        BombClass = class<FoxGameObject_Bomb>(DynamicLoadObject("FoxGameContent_SND.FoxGameObject_BombContent", class'Class'));
        SNDGRI.BombObject = Spawn(BombClass, SNDGRI,, InPlayer.Pawn.Location,,, true);
        PendingBombPickupPlayer = none;
        SNDGRI.BombObject.Pickup(InPlayer.MyFoxPawn);
        InPlayer.ClientReliableTeamScoreEvent(65, byte(InPlayer.PlayerReplicationInfo.Team.TeamIndex));
        TeamScoreEvent(DefendingTeamIndex, 63, true);
        // End:0x280
        foreach WorldInfo.AllControllers(class'FoxPC', PC)
        {
            // End:0x27F
            if((PC.GetTeamNum() == AttackingTeamIndex) && PC != InPlayer)
            {
                PC.ClientNotifyBombInPlay(InPlayer.PlayerReplicationInfo);
            }            
        }        
    }
    bNeedBombCarrier = false;
    //return;    
}

function OnDelayedRespawnBomb()
{
    local array<PlayerStart> ListOfPlayerStarts;
    local PlayerStart CurrentStart;
    local int RandomIndex;
    local class<FoxGameObject_Bomb> BombClass;

    // End:0x6E
    if(((SNDGRI.BombObject != none) || FGRI.bRoundInTransition) || FGRI.bMatchIsOver)
    {
        return;
    }
    // End:0xE5
    foreach WorldInfo.AllNavigationPoints(class'PlayerStart', CurrentStart)
    {
        // End:0xE4
        if(CurrentStart.TeamIndex == AttackingTeamIndex)
        {
            ListOfPlayerStarts.AddItem(CurrentStart);
        }        
    }    
    // End:0xF8
    if(ListOfPlayerStarts.Length == 0)
    {
        return;
    }
    RandomIndex = Rand(ListOfPlayerStarts.Length);
    BombClass = class<FoxGameObject_Bomb>(DynamicLoadObject("FoxGameContent_SND.FoxGameObject_BombContent", class'Class'));
    SNDGRI.BombObject = Spawn(BombClass, SNDGRI,, ListOfPlayerStarts[RandomIndex].Location,,, true);
    SNDGRI.BombObject.ObjectMesh.SetRotation(rot(0, 0, 0));
    SNDGRI.BombObject.ObjectCylinder.SetCylinderSize(0.0, 0.0);
    SNDGRI.BombObject.ObjectCylinder.SetActorCollision(true, false, false);
    SNDGRI.BombObject.CollisionComponent = SNDGRI.BombObject.ObjectMesh;
    SNDGRI.BombObject.SetPhysics(2);
    //return;    
}

protected function OnNextRoundBegin()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x5A [Loop If]
    if(I < BombTargets.Length)
    {
        BombTargets[I].Reset();
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    RestartInitialBombSpawnTimer();
    super.OnNextRoundBegin();
    //return;    
}

function bool CheckScore(PlayerReplicationInfo TestPRI)
{
    return false;
    //return ReturnValue;    
}

function ScoreValidKill(Controller Killer, Controller KilledPlayer)
{
    super(FoxGame).ScoreValidKill(Killer, KilledPlayer);
    //return;    
}

function PlayDeathRoundEnd(Pawn KillerPawn, Pawn VictimPawn)
{
    // End:0xC1
    if((!bPendingRoundEnd && SNDGRI.BombObject != none) && SNDGRI.BombObject.bIsPlanted)
    {
        SNDGRI.BombObject.OnRoundEnd();
        SNDGRI.FreezeBombTimer();
    }
    super.PlayDeathRoundEnd(KillerPawn, VictimPawn);
    //return;    
}

protected function HandleRoundEnd()
{
    local FoxPC PC;

    SNDGRI.FreezeBombTimer();
    // End:0x83
    if(!ShouldEndRoundGame())
    {
        // End:0x82
        foreach WorldInfo.AllControllers(class'FoxPC', PC)
        {
            PC.AddLoadoutSwapper();            
        }        
    }
    super.HandleRoundEnd();
    //return;    
}

defaultproperties
{
    DefendingTeamIndex=1
    LocStringTeam1Name="[A]ATTACK"
    LocStringTeam2Name="[B]DEFEND"
    TeamChangeThreshold=60
    bRoundEndsByTime=true
    bSupportsBots=false
    bFreezeAtStart=true
    GameTypeStatsClass=class'FoxOnlineStatsWriteGameTypeSND'
    GameModeContext=10
    GameTypeString="Search And Destroy"
    GameTypeAbbreviatedName="SND"
    MinRounds=2
    NumRounds=10
    HUDType=class'FoxHudSND'
    GoalScore=1
    TimeLimit=3
    GameReplicationInfoClass=class'FoxGRI_SND'
    OnlineGameSettingsClass=class'FoxGameSettingsSND'
}